import Comparator, { CompareFunction } from "@utilityjs/comparator";
import MinHeap from "@utilityjs/min-heap";
export default class PriorityQueue<T> extends MinHeap<T> {
    private priorities;
    private valueComparator;
    constructor(compareFunction?: CompareFunction<T>);
    add(item: T, priority?: number): void;
    remove(item: T, comparator?: Comparator<T>): void;
    changePriority(item: T, priority: number): void;
    findByValue(item: T): number[];
    hasValue(item: T): boolean;
}
