var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import Comparator from "@utilityjs/comparator";
import MinHeap from "@utilityjs/min-heap";
var PriorityQueue = /** @class */ (function (_super) {
    __extends(PriorityQueue, _super);
    function PriorityQueue(compareFunction) {
        var _this = 
        // eslint-disable-next-line
        _super.call(this) || this;
        _this.priorities = new Map();
        _this.valueComparator = new Comparator(compareFunction);
        _this.comparator = new Comparator(function (a, b) {
            var pA = _this.priorities.get(a);
            var pB = _this.priorities.get(b);
            if (typeof pA !== "number" || typeof pB !== "number")
                throw new ReferenceError();
            if (pA === pB)
                return 0;
            return pA < pB ? -1 : 1;
        });
        return _this;
    }
    PriorityQueue.prototype.add = function (item, priority) {
        if (priority === void 0) { priority = 0; }
        this.priorities.set(item, priority);
        // eslint-disable-next-line
        _super.prototype.add.call(this, item);
    };
    PriorityQueue.prototype.remove = function (item, comparator) {
        // eslint-disable-next-line
        _super.prototype.remove.call(this, item, comparator !== null && comparator !== void 0 ? comparator : this.valueComparator);
        this.priorities.delete(item);
    };
    PriorityQueue.prototype.changePriority = function (item, priority) {
        this.remove(item);
        this.add(item, priority);
    };
    PriorityQueue.prototype.findByValue = function (item) {
        // eslint-disable-next-line
        return this.find(item, this.valueComparator);
    };
    PriorityQueue.prototype.hasValue = function (item) {
        return this.findByValue(item).length > 0;
    };
    return PriorityQueue;
}(MinHeap));
export default PriorityQueue;
